#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'hostprofiles.ui'
**
** Created: 2012-08-28T12:52:53
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "hostprofiles.h"

#include <qvariant.h>
#include <kdialog.h>
#include <qheader.h>
#include <klistview.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "hostprofiles.ui.h"

/*
 *  Constructs a HostProfiles as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
HostProfiles::HostProfiles( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "HostProfiles" );
    HostProfilesLayout = new QGridLayout( this, 1, 1, 0, KDialog::spacingHint(), "HostProfilesLayout"); 

    hostListView = new KListView( this, "hostListView" );
    hostListView->addColumn( tr2i18n( "Host" ) );
    hostListView->addColumn( tr2i18n( "Type" ) );
    hostListView->addColumn( tr2i18n( "Settings" ) );
    hostListView->setProperty( "selectionMode", "Multi" );
    hostListView->setAllColumnsShowFocus( TRUE );
    hostListView->setFullWidth( TRUE );
    hostListView->setItemsMovable( FALSE );

    HostProfilesLayout->addMultiCellWidget( hostListView, 0, 0, 0, 2 );
    spacer3 = new QSpacerItem( 117, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    HostProfilesLayout->addItem( spacer3, 1, 0 );

    removeHostButton = new QPushButton( this, "removeHostButton" );

    HostProfilesLayout->addWidget( removeHostButton, 1, 1 );

    removeAllButton = new QPushButton( this, "removeAllButton" );

    HostProfilesLayout->addWidget( removeAllButton, 1, 2 );
    languageChange();
    resize( QSize(451, 222).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( removeHostButton, SIGNAL( clicked() ), this, SLOT( removeHost() ) );
    connect( removeAllButton, SIGNAL( clicked() ), this, SLOT( removeAllHosts() ) );
    connect( hostListView, SIGNAL( selectionChanged() ), this, SLOT( selectionChanged() ) );
    connect( hostListView, SIGNAL( doubleClicked(QListViewItem*,const QPoint&,int) ), this, SLOT( slotHostDoubleClicked(QListViewItem*) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
HostProfiles::~HostProfiles()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void HostProfiles::languageChange()
{
    hostListView->header()->setLabel( 0, tr2i18n( "Host" ) );
    hostListView->header()->setLabel( 1, tr2i18n( "Type" ) );
    hostListView->header()->setLabel( 2, tr2i18n( "Settings" ) );
    QWhatsThis::add( hostListView, tr2i18n( "This list shows all hosts that you have visited and a summary of your settings for them. If you want to reset the setting for a host, you can delete it using the buttons below. When you connect again you can then re-configure them." ) );
    removeHostButton->setText( tr2i18n( "&Remove Selected Host" ) );
    QWhatsThis::add( removeHostButton, tr2i18n( "Deletes the hosts that you have selected in the list above." ) );
    removeAllButton->setText( tr2i18n( "Remove &All Hosts" ) );
    QWhatsThis::add( removeAllButton, tr2i18n( "Removes all hosts from the list." ) );
}

/****************************************************************************
** HostProfiles meta object code from reading C++ file 'hostprofiles.h'
**
** Created: Tue Aug 28 12:52:54 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "hostprofiles.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *HostProfiles::className() const
{
    return "HostProfiles";
}

QMetaObject *HostProfiles::metaObj = 0;
static QMetaObjectCleanUp cleanUp_HostProfiles( "HostProfiles", &HostProfiles::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString HostProfiles::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "HostProfiles", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString HostProfiles::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "HostProfiles", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* HostProfiles::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUMethod slot_0 = {"removeHost", 0, 0 };
    static const QUParameter param_slot_1[] = {
	{ 0, &static_QUType_ptr, "QListViewItem", QUParameter::In }
    };
    static const QUMethod slot_1 = {"slotHostDoubleClicked", 1, param_slot_1 };
    static const QUMethod slot_2 = {"languageChange", 0, 0 };
    static const QUMethod slot_3 = {"removeAllHosts", 0, 0 };
    static const QUMethod slot_4 = {"selectionChanged", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "removeHost()", &slot_0, QMetaData::Public },
	{ "slotHostDoubleClicked(QListViewItem*)", &slot_1, QMetaData::Public },
	{ "languageChange()", &slot_2, QMetaData::Protected },
	{ "removeAllHosts()", &slot_3, QMetaData::Protected },
	{ "selectionChanged()", &slot_4, QMetaData::Protected }
    };
    static const QUParameter param_signal_0[] = {
	{ 0, &static_QUType_ptr, "HostPrefPtr", QUParameter::In }
    };
    static const QUMethod signal_0 = {"hostDoubleClicked", 1, param_signal_0 };
    static const QMetaData signal_tbl[] = {
	{ "hostDoubleClicked(HostPrefPtr)", &signal_0, QMetaData::Public }
    };
    metaObj = QMetaObject::new_metaobject(
	"HostProfiles", parentObject,
	slot_tbl, 5,
	signal_tbl, 1,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_HostProfiles.setMetaObject( metaObj );
    return metaObj;
}

void* HostProfiles::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "HostProfiles" ) )
	return this;
    return QWidget::qt_cast( clname );
}

#include <qobjectdefs.h>
#include <qsignalslotimp.h>

// SIGNAL hostDoubleClicked
void HostProfiles::hostDoubleClicked( HostPrefPtr t0 )
{
    if ( signalsBlocked() )
	return;
    QConnectionList *clist = receivers( staticMetaObject()->signalOffset() + 0 );
    if ( !clist )
	return;
    QUObject o[2];
    static_QUType_ptr.set(o+1,&t0);
    activate_signal( clist, o );
}

bool HostProfiles::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: removeHost(); break;
    case 1: slotHostDoubleClicked((QListViewItem*)static_QUType_ptr.get(_o+1)); break;
    case 2: languageChange(); break;
    case 3: removeAllHosts(); break;
    case 4: selectionChanged(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool HostProfiles::qt_emit( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->signalOffset() ) {
    case 0: hostDoubleClicked((HostPrefPtr)(*((HostPrefPtr*)static_QUType_ptr.get(_o+1)))); break;
    default:
	return QWidget::qt_emit(_id,_o);
    }
    return TRUE;
}
#ifndef QT_NO_PROPERTIES

bool HostProfiles::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool HostProfiles::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
