#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'vncprefs.ui'
**
** Created: 2012-08-28T12:52:15
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "vncprefs.h"

#include <qvariant.h>
#include <kdialog.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "vncprefs.ui.h"

/*
 *  Constructs a VncPrefs as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
VncPrefs::VncPrefs( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "VncPrefs" );
    VncPrefsLayout = new QVBoxLayout( this, 0, KDialog::spacingHint(), "VncPrefsLayout"); 

    groupBox = new QGroupBox( this, "groupBox" );
    groupBox->setColumnLayout(0, Qt::Vertical );
    groupBox->layout()->setSpacing( KDialog::spacingHint() );
    groupBox->layout()->setMargin( KDialog::marginHint() );
    groupBoxLayout = new QGridLayout( groupBox->layout() );
    groupBoxLayout->setAlignment( Qt::AlignTop );

    cbUseEncryption = new QCheckBox( groupBox, "cbUseEncryption" );
    cbUseEncryption->setEnabled( FALSE );

    groupBoxLayout->addMultiCellWidget( cbUseEncryption, 1, 1, 0, 2 );

    cbUseKWallet = new QCheckBox( groupBox, "cbUseKWallet" );
    cbUseKWallet->setEnabled( TRUE );

    groupBoxLayout->addMultiCellWidget( cbUseKWallet, 2, 2, 0, 2 );

    connectionTypeLabel = new QLabel( groupBox, "connectionTypeLabel" );
    connectionTypeLabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)1, 0, 0, connectionTypeLabel->sizePolicy().hasHeightForWidth() ) );

    groupBoxLayout->addWidget( connectionTypeLabel, 0, 0 );

    cmbQuality = new QComboBox( FALSE, groupBox, "cmbQuality" );
    cmbQuality->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, cmbQuality->sizePolicy().hasHeightForWidth() ) );
    cmbQuality->setMinimumSize( QSize( 280, 0 ) );

    groupBoxLayout->addWidget( cmbQuality, 0, 1 );
    Spacer = new QSpacerItem( 84, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    groupBoxLayout->addItem( Spacer, 0, 2 );
    VncPrefsLayout->addWidget( groupBox );

    cbShowPrefs = new QCheckBox( this, "cbShowPrefs" );
    VncPrefsLayout->addWidget( cbShowPrefs );
    languageChange();
    resize( QSize(472, 126).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // buddies
    connectionTypeLabel->setBuddy( cmbQuality );
}

/*
 *  Destroys the object and frees any allocated resources
 */
VncPrefs::~VncPrefs()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void VncPrefs::languageChange()
{
    groupBox->setTitle( tr2i18n( "Connection" ) );
    cbUseEncryption->setText( tr2i18n( "&Enable encryption (secure, but slow and not always possible)" ) );
    QWhatsThis::add( cbUseEncryption, tr2i18n( "Enable this option to encrypt the connection. Only newer servers support this option. Encrypting prevents others from eavesdropping, but can slow down the connection considerably." ) );
    cbUseKWallet->setText( tr2i18n( "Use K&Wallet for passwords" ) );
    QWhatsThis::add( cbUseKWallet, tr2i18n( "Enable this option to store your passwords with KWallet." ) );
    connectionTypeLabel->setText( tr2i18n( "Connection &type:" ) );
    cmbQuality->clear();
    cmbQuality->insertItem( tr2i18n( "High Quality (LAN, direct connection)" ) );
    cmbQuality->insertItem( tr2i18n( "Medium Quality (DSL, Cable, fast Internet)" ) );
    cmbQuality->insertItem( tr2i18n( "Low Quality (Modem, ISDN, slow Internet)" ) );
    QWhatsThis::add( cmbQuality, tr2i18n( "Use this to specify the performance of your connection. Note that you should select the speed of the weakest link - even if you have a high speed connection, it will not help you if the remote computer uses a slow modem. Choosing a level of quality that is too high on a slow link will cause slower response times. Choosing a lower quality will increase latencies in high speed connections and results in lower image quality, especially in 'Low Quality' mode." ) );
    cbShowPrefs->setText( tr2i18n( "&Show this dialog again for this host" ) );
    QWhatsThis::add( cbShowPrefs, tr2i18n( "Select this option if you do not want to be asked for the settings when connecting to a host. For hosts with existing profiles these profiles will be taken. New hosts will be configured with the defaults." ) );
}

/****************************************************************************
** VncPrefs meta object code from reading C++ file 'vncprefs.h'
**
** Created: Tue Aug 28 12:52:15 2012
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "vncprefs.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *VncPrefs::className() const
{
    return "VncPrefs";
}

QMetaObject *VncPrefs::metaObj = 0;
static QMetaObjectCleanUp cleanUp_VncPrefs( "VncPrefs", &VncPrefs::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString VncPrefs::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "VncPrefs", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString VncPrefs::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "VncPrefs", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* VncPrefs::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUMethod slot_0 = {"languageChange", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "languageChange()", &slot_0, QMetaData::Protected }
    };
    metaObj = QMetaObject::new_metaobject(
	"VncPrefs", parentObject,
	slot_tbl, 1,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_VncPrefs.setMetaObject( metaObj );
    return metaObj;
}

void* VncPrefs::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "VncPrefs" ) )
	return this;
    return QWidget::qt_cast( clname );
}

bool VncPrefs::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: languageChange(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool VncPrefs::qt_emit( int _id, QUObject* _o )
{
    return QWidget::qt_emit(_id,_o);
}
#ifndef QT_NO_PROPERTIES

bool VncPrefs::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool VncPrefs::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
